DEFAULT_BUTTON_SCALE = 0.8
LARGE_BUTTON_SCALE = 1
ADD_BUTTON_SCALE = 1

SPELLS_DEFAULT = {
	["mwActionTopLeft"] = 322101,
	["mwActionTopRight"] = 388615,

	["mwActionBottomLeft"] = 115313,
	["mwActionBottomRight"] = 122783,
	["mwActionBottomLeft2"] = 322118,
	["mwActionBottomRight2"] = 116844,

	["mwActionHealthLeftclick"] = 115175,
	["mwActionHealthRightclick"] = 124682,
	["mwActionHealthShiftLeftclick"] = 115098,
	["mwActionHealthShiftRightclick"] = 116849,

	["mwActionRenewingMistLeftclick"] = 115151,
	["mwActionRenewingMistRightclick"] = 116670,
	["mwActionRenewingMistShiftLeftclick"] = 116841,
	["mwActionRenewingMistShiftRightclick"] = 124081,

	["mwAdditionalActionButton1"] = 122281,
	["mwAdditionalActionButton2"] = 116680,
	["mwAdditionalActionButton3"] = 197908,
	["mwAdditionalActionButton4"] = 115203
}

function MistWeaver_InitActionButtons()
    MistWeaverSpells = MistWeaverSpells or SPELLS_DEFAULT;

    -- top buttons

    local mwActionTopLeft = MistWeaver_CreateActionButton("mwActionTopLeft", nil);    
    mwActionTopLeft:SetPoint("TOPRIGHT", MistWeaverFrame, "TOPLEFT", -2, 0);
    mwActionTopLeft:SetFrameStrata("LOW");
    mwActionTopLeft:SetScale(LARGE_BUTTON_SCALE);

    local mwActionTopRight = MistWeaver_CreateActionButton("mwActionTopRight", nil);    
    mwActionTopRight:SetPoint("TOPLEFT", MistWeaverFrame, "TOPLEFT", 2, 0);
    mwActionTopRight:SetFrameStrata("LOW");
    mwActionTopRight:SetScale(LARGE_BUTTON_SCALE);

    -- mana bar

    local mwPowerFrame = CreateFrame("Frame", "MwPowerFrame", MistWeaverFrame, "BackdropTemplate");
    mwPowerFrame:ClearAllPoints();
    mwPowerFrame:SetPoint("TOPLEFT", mwActionTopRight, "TOPRIGHT", 4, 0);
    mwPowerFrame:SetPoint("BOTTOMLEFT", mwActionTopRight, "BOTTOMRIGHT", 4, 0);
    mwPowerFrame:SetWidth(125);
    MistWeaver_SetBackdrop(mwPowerFrame);
    mwPowerFrame:SetFrameStrata("LOW");
    
    local mwManaBar = CreateFrame("StatusBar", "MwManaBar", mwPowerFrame, "MwTextStatusBarTemplate");
    mwManaBar:ClearAllPoints();
    mwManaBar:SetPoint("TOPLEFT", mwPowerFrame, "TOPLEFT", 2, -2);
    mwManaBar:SetPoint("BOTTOMRIGHT", mwPowerFrame, "BOTTOMRIGHT", -3, 2);
    mwManaBar:SetStatusBarColor(PowerBarColor["MANA"].r, PowerBarColor["MANA"].g, PowerBarColor["MANA"].b);

    -- additional buttons

    local mwAdditionalActionButton1 = MistWeaver_CreateActionButton("mwAdditionalActionButton1", nil);    
    mwAdditionalActionButton1:SetPoint("TOPLEFT", mwPowerFrame, "TOPRIGHT", 4, 0);
    mwAdditionalActionButton1:SetFrameStrata("LOW");
    mwAdditionalActionButton1:SetScale(ADD_BUTTON_SCALE);

    local mwAdditionalActionButton2 = MistWeaver_CreateActionButton("mwAdditionalActionButton2", nil);    
    mwAdditionalActionButton2:SetPoint("TOPLEFT", mwAdditionalActionButton1, "TOPRIGHT", 4, 0);
    mwAdditionalActionButton2:SetFrameStrata("LOW");
    mwAdditionalActionButton2:SetScale(ADD_BUTTON_SCALE);

    local mwAdditionalActionButton3 = MistWeaver_CreateActionButton("mwAdditionalActionButton3", nil);    
    mwAdditionalActionButton3:SetPoint("TOPLEFT", mwAdditionalActionButton2, "TOPRIGHT", 4, 0);
    mwAdditionalActionButton3:SetFrameStrata("LOW");
    mwAdditionalActionButton3:SetScale(ADD_BUTTON_SCALE);

    local mwAdditionalActionButton4 = MistWeaver_CreateActionButton("mwAdditionalActionButton4", nil);    
    mwAdditionalActionButton4:SetPoint("TOPLEFT", mwAdditionalActionButton3, "TOPRIGHT", 4, 0);
    mwAdditionalActionButton4:SetFrameStrata("LOW");
    mwAdditionalActionButton4:SetScale(ADD_BUTTON_SCALE);

    -- health bar buttons

    local mwActionHealthLeftclick = MistWeaver_CreateActionButton("mwActionHealthLeftclick", nil);    
    mwActionHealthLeftclick:SetPoint("TOPRIGHT", mwActionTopLeft, "BOTTOMRIGHT", 0, -12);
    mwActionHealthLeftclick:SetFrameStrata("LOW");
    mwActionHealthLeftclick:SetScale(DEFAULT_BUTTON_SCALE);
    mwActionHealthLeftclick.tooltip = "The spell will be triggered by left-clicking on the health bar.";

    local mwActionHealthRightclick = MistWeaver_CreateActionButton("mwActionHealthRightclick", nil);    
    mwActionHealthRightclick:SetPoint("TOPLEFT", mwActionTopRight, "BOTTOMLEFT", 0, -12);
    mwActionHealthRightclick:SetFrameStrata("LOW");
    mwActionHealthRightclick:SetScale(DEFAULT_BUTTON_SCALE);
    mwActionHealthRightclick.tooltip = "The spell will be triggered by right-clicking on the health bar.";

    local mwActionHealthShiftLeftclick = MistWeaver_CreateActionButton("mwActionHealthShiftLeftclick", nil);    
    mwActionHealthShiftLeftclick:SetPoint("TOPRIGHT", mwActionHealthLeftclick, "BOTTOMRIGHT", 0, -4);
    mwActionHealthShiftLeftclick:SetFrameStrata("LOW");
    mwActionHealthShiftLeftclick:SetScale(DEFAULT_BUTTON_SCALE);
    mwActionHealthShiftLeftclick.tooltip = "The spell will be triggered by [shift]+left-clicking on the health bar.";

    local mwActionHealthShiftRightclick = MistWeaver_CreateActionButton("mwActionHealthShiftRightclick", nil);    
    mwActionHealthShiftRightclick:SetPoint("TOPLEFT", mwActionHealthRightclick, "BOTTOMLEFT", 0, -4);
    mwActionHealthShiftRightclick:SetFrameStrata("LOW");
    mwActionHealthShiftRightclick:SetScale(DEFAULT_BUTTON_SCALE);
    mwActionHealthShiftRightclick.tooltip = "The spell will be triggered by [shift]+right-clicking on the health bar.";

    -- renewing mist bar buttons

    local mwActionRenewingMistLeftclick = MistWeaver_CreateActionButton("mwActionRenewingMistLeftclick", nil);    
    mwActionRenewingMistLeftclick:SetPoint("TOPRIGHT", mwActionHealthShiftLeftclick, "BOTTOMRIGHT", 0, -10);
    mwActionRenewingMistLeftclick:SetFrameStrata("LOW");
    mwActionRenewingMistLeftclick:SetScale(DEFAULT_BUTTON_SCALE);
    mwActionRenewingMistLeftclick.tooltip = "The spell will be triggered by left-clicking on the renewing mist bar.";

    local mwActionRenewingMistRightclick = MistWeaver_CreateActionButton("mwActionRenewingMistRightclick", nil);    
    mwActionRenewingMistRightclick:SetPoint("TOPLEFT", mwActionHealthShiftRightclick, "BOTTOMLEFT", 0, -10);
    mwActionRenewingMistRightclick:SetFrameStrata("LOW");
    mwActionRenewingMistRightclick:SetScale(DEFAULT_BUTTON_SCALE);
    mwActionRenewingMistRightclick.tooltip = "The spell will be triggered by right-clicking on the renewing mist bar.";

    local mwActionRenewingMistShiftLeftclick = MistWeaver_CreateActionButton("mwActionRenewingMistShiftLeftclick", nil);    
    mwActionRenewingMistShiftLeftclick:SetPoint("TOPRIGHT", mwActionRenewingMistLeftclick, "BOTTOMRIGHT", 0, -4);
    mwActionRenewingMistShiftLeftclick:SetFrameStrata("LOW");
    mwActionRenewingMistShiftLeftclick:SetScale(DEFAULT_BUTTON_SCALE);
    mwActionRenewingMistShiftLeftclick.tooltip = "The spell will be triggered by [shift]+left-clicking on the renewing mist bar.";

    local mwActionRenewingMistShiftRightclick = MistWeaver_CreateActionButton("mwActionRenewingMistShiftRightclick", nil);    
    mwActionRenewingMistShiftRightclick:SetPoint("TOPLEFT", mwActionRenewingMistRightclick, "BOTTOMLEFT", 0, -4);
    mwActionRenewingMistShiftRightclick:SetFrameStrata("LOW");
    mwActionRenewingMistShiftRightclick:SetScale(DEFAULT_BUTTON_SCALE);
    mwActionRenewingMistShiftRightclick.tooltip = "The spell will be triggered by [shift]+right-clicking on the renewing mist bar.";

    -- bottom buttons

    local mwActionBottomLeft = MistWeaver_CreateActionButton("mwActionBottomLeft", nil);    
    mwActionBottomLeft:SetPoint("TOPRIGHT", mwActionRenewingMistShiftLeftclick, "BOTTOMRIGHT", 0, -12);
    mwActionBottomLeft:SetFrameStrata("LOW");
    mwActionBottomLeft:SetScale(LARGE_BUTTON_SCALE);

    local mwActionBottomRight = MistWeaver_CreateActionButton("mwActionBottomRight", nil);    
    mwActionBottomRight:SetPoint("TOPLEFT", mwActionRenewingMistShiftRightclick, "BOTTOMLEFT", 0, -12);
    mwActionBottomRight:SetFrameStrata("LOW");
    mwActionBottomRight:SetScale(LARGE_BUTTON_SCALE);

    local mwActionBottomLeft2 = MistWeaver_CreateActionButton("mwActionBottomLeft2", nil);    
    mwActionBottomLeft2:SetPoint("TOPRIGHT", mwActionBottomLeft, "BOTTOMRIGHT", 0, -4);
    mwActionBottomLeft2:SetFrameStrata("LOW");
    mwActionBottomLeft2:SetScale(LARGE_BUTTON_SCALE);

    local mwActionBottomRight2 = MistWeaver_CreateActionButton("mwActionBottomRight2", nil);    
    mwActionBottomRight2:SetPoint("TOPLEFT", mwActionBottomRight, "BOTTOMLEFT", 0, -4);
    mwActionBottomRight2:SetFrameStrata("LOW");
    mwActionBottomRight2:SetScale(LARGE_BUTTON_SCALE);
end

function MistWeaver_CreateActionButton(name, id, unit, disableDragAndDrop)
    local button = _G[name];
    local spellId = MistWeaverSpells[name];
    
    if (not button) then
        button = CreateFrame("Button", name, MistWeaverFrame, "SecureActionButtonTemplate, ActionButtonTemplate");

        button:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
        button:RegisterEvent("ACTIONBAR_UPDATE_STATE");
        button:RegisterEvent("ZONE_CHANGED");
        button:RegisterEvent("ZONE_CHANGED_INDOORS");
        button:RegisterEvent("ZONE_CHANGED_NEW_AREA");
        button:RegisterEvent("PLAYER_REGEN_DISABLED");
        button:RegisterEvent("PLAYER_REGEN_ENABLED");
        
        button:RegisterEvent("ACTIONBAR_SHOWGRID");
        button:RegisterEvent("ACTIONBAR_HIDEGRID");

        button:RegisterForDrag("LeftButton");
    end
    
    button:Show();
    
    -- Texture
    local spellname, rank, texture = GetSpellInfo(spellId);
    button.icon:SetTexture(texture);
    
    if (MASQUE and buttongroupItems) then
        buttongroupItems:AddButton(button);
    end

    local spellName = GetSpellInfo(spellId);

    button:SetAttribute("unit", unit or "player");

    button:SetAttribute("type", "spell");
    button:SetAttribute("spell", spellName);
    button:SetAttribute("id", spellId);
    button:SetAttribute("mw_name", name);

    button.cooldown = _G[button:GetName().."Cooldown"];
    button.cooldown:ClearAllPoints();
    button.cooldown:SetPoint("TOPLEFT", button, "TOPLEFT", 0, -0);
    button.cooldown:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -0, 0);
    
    button.cooldown:SetEdgeTexture("Interface\\Cooldown\\edge");
    button.cooldown:SetSwipeColor(0, 0, 0);
    button.cooldown:SetHideCountdownNumbers(false);
    button.cooldown.currentCooldownType = COOLDOWN_TYPE_NORMAL;

    button.HighlightTexture:ClearAllPoints();
    button.HighlightTexture:SetPoint("TOPLEFT", -1, 1);
    button.HighlightTexture:SetPoint("BOTTOMRIGHT", 3, -2);
    
    button:HookScript("OnEnter", Mistweaver_ShowActionButtonTooltip);
    button:HookScript("OnLeave", Mistweaver_HideActionButtonTooltip);

    if (disableDragAndDrop ~= true) then
        button:HookScript("OnReceiveDrag", MistWeaver_ActionButton_OnReceiveDrag);
        button:HookScript("OnDragStart", MistWeaver_ActionButton_OnDragStart);
        button:HookScript("OnDragStop", MistWeaver_ActionButton_OnDragStop);
    end
    
    button:HookScript("OnEvent", MistWeaver_ActionButton_OnEvent); 
    MistWeaver_ActionButton_OnEvent(button, "BAG_UPDATE");

    if (spellId == nil) then
        button:SetAlpha(0);
    end

    button.dnd = true;

    return button;
end

function MistWeaver_ActionButton_OnEvent(self, event, ...)
    if ( event == "ACTIONBAR_UPDATE_COOLDOWN" ) then
        MistWeaver_ActionButtonUpdateCooldown(self);
    end
    if ( event == "ACTIONBAR_UPDATE_STATE" or event == "ZONE_CHANGED" or event == "ZONE_CHANGED_INDOORS"  or event == "ZONE_CHANGED_NEW_AREA" or event == "PLAYER_REGEN_DISABLED" or event == "PLAYER_REGEN_ENABLED" ) then
        MistWeaver_CheckActionButtonUsable(self);
    end
    
    if ( event == "ACTIONBAR_SHOWGRID") then
        self:SetAlpha(1);
    end
    if ( event == "ACTIONBAR_HIDEGRID") then
        if (MistWeaverSpells[self:GetName()] == nil) then
            self:SetAlpha(0);
        end
    end
end

function Mistweaver_ShowActionButtonTooltip(self)
    GameTooltip_SetDefaultAnchor(GameTooltip, self);

    local spellId = self:GetAttribute("id");

    if (spellId) then
        GameTooltip:SetSpellByID(spellId);

        if (self.dnd) then
            GameTooltip:AddLine(" ", 1.0, 1.0, 1.0);
            GameTooltip:AddLine("Drop any spell you want from the spell book.", 1.0, 1.0, 1.0);
        end

        if (self.tooltip ~= nil) then
            GameTooltip:AddLine(" ", 1.0, 1.0, 1.0);
            GameTooltip:AddLine(self.tooltip, 1.0, 1.0, 1.0);
        end

        GameTooltip:Show();
    end
end

function Mistweaver_HideActionButtonTooltip()
    GameTooltip:FadeOut();
end

function MistWeaver_ActionButton_OnReceiveDrag(self)
    local infoType, info1, info2 = GetCursorInfo();
    local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(info1, BOOKTYPE_SPELL);

    local mw_name = self:GetAttribute("mw_name");

    if (infoType == "spell" and info1 ~= nil) then
        if (self:GetAttribute("mw_name") ~= nil) then
            MistWeaverSpells[mw_name] = spellId;            
            MistWeaver_InitActionButtons();
            MistWeaver_UnitFrames_RebindSpells(MistWeaverSpells);
        end
    end

    MistWeaver_ActionButtonUpdateCooldown(self);

    ClearCursor();
end

function MistWeaver_ActionButton_OnDragStart(self)
    if (IsShiftKeyDown()) then
        local mw_name = self:GetAttribute("mw_name");
        
        if (MistWeaverSpells[mw_name] ~= nil) then
            --PickupSpell(MistWeaverSpells[mw_name])
        end

        MistWeaverSpells[mw_name] = nil;      
        self:SetAlpha(0);      
        MistWeaver_InitActionButtons();
        MistWeaver_UnitFrames_RebindSpells(MistWeaverSpells);
    end
end

function MistWeaver_ActionButton_OnDragStop(self)
    ClearCursor();
end

function MistWeaver_ActionButtonUpdateCooldown(self)
    local cooldown = self.cooldown;
    local spellId = self:GetAttribute("id");

    if (spellId) then
        local start, duration, enable = GetSpellCooldown(spellId);
        CooldownFrame_Set(cooldown, start, duration, enable);
    end
end

function MistWeaver_CheckActionButtonUsable(self)
    local spellId = self:GetAttribute("id");

    if (spellId and not InCombatLockdown()) then
        local isUsable = IsUsableSpell(spellId);
        
        self:Show();
        if (isUsable) then
            self.icon:SetAlpha(1.0);
        else
            self.icon:SetAlpha(0.3);
        end
    end
end

function MistWeaver_UpdatePower() -- on update
    local mwManaBar = _G["MwManaBar"];

    local mana = UnitPower("player", SPELL_POWER_MANA);
    local manaMax = UnitPowerMax("player", SPELL_POWER_MANA);

    mwManaBar:SetMinMaxValues(0, manaMax);
    mwManaBar:SetValue(mana);

    if (manaMax ~= 0) then
        mwManaBar.text:SetText(format("%.0f", (100 * mana / manaMax)).." %");
    end
end
